
//--------------------------------------
//	΂Nbv
//	tabasa_clip.cpp ver. 1.995
//	
//	_clip.txt
//	Nbv{[h̃eLXgۑ
//	
//	f[^}[Ni\a\nj́AK
//	borlandcł͂߁H
//	2000/12/08()-2001/04/16()-
//	1991-2002 Copyright tabasa & charlie, All rights reserved
// 	happypoint@geocities.co.jp
//	http://www.geocities.co.jp/SiliconValley-Bay/6716/
//
//

/*-----------------------------------------
   cf.	CLIPVIEW.C -- Simple Clipboard Viewer
                 (c) Charles Petzold, 1998
  -----------------------------------------*/
#define	_main
#include "defextern.h"

#include <windows.h>
#include <windowsx.h>
#include "resource.h"
#include <commdlg.h>
//#include <commctrl.h>
#include <iostream.h>
#include <fstream.h>
#include <list>
#include "lang.h"
#include "tabasa.h"
#include "clip.h"
#include "menu.h"
#include "taskbaricon.h"
#include "jis.h"


LRESULT CALLBACK SpDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp);

OPENFILENAME ofn;
HICON taskicon;
CTaskbarIcon ticon;
long index;

COLORREF	colorsc=RGB(0x00,0xff,0x4f);
TCHAR titleform[] = TEXT ("[in:%s]-index:%u/%u-[len:%d][%d/%d/%d]") ;

char LDOWN=',';
char RDOWN='.';
char LDOWNS='<';
char RDOWNS='>';
char FILECH='\\';

TCHAR szAccelName[] = TEXT ("tabasa_clip") ;
TCHAR szAppName[] = TEXT ("tabasa_clip") ;
const int titlemax=namemax-strlen(szTitleName)-3;
	
char pathname[buffmax];
char titlename[buffmax];

#define TEMP_POPUP 0
#define ADD_POPUP 1
#define ALL_POPUP 2
#define SP_POPUP 3

struct popup
{
	int mode;
	HMENU menu;
	void setmode(int m)
	{
		mode=m;
		if(m==TEMP_POPUP) setmenu(hTempClipMenu);
		if(m==ADD_POPUP) setmenu(hClipMenu);
		if(m==ALL_POPUP) setmenu(hMainMenu);
		if(m==SP_POPUP) setmenu(hSpMenu);
	}
	void setmenu(HMENU m) 
	{
		menu=m;
	};
};

popup pop;



#ifdef UNICODE

#define CF_TCHAR CF_UNICODETEXT
TCHAR szDefaultText[] = TEXT ("Default Text - Unicode Version") ;
TCHAR szCaption[]     = TEXT ("Clipboard Text Transfers - Unicode Version") ;

#else

#define CF_TCHAR CF_TEXT
TCHAR szDefaultText[] = TEXT ("Default Text - ANSI Version") ;
TCHAR szCaption[]     = TEXT ("Clipboard Text Transfers - ANSI Version") ;

#endif


//-----------------------------------------------------------------------
//	

void PopFileInitialize (HWND hwnd)
{
     static TCHAR szFilter[] = TEXT ("Text Files (*.TXT)\0*.txt\0")  \
                               TEXT ("ASCII Files (*.ASC)\0*.asc\0") \
                               TEXT ("All Files (*.*)\0*.*\0\0") ;
     
     ofn.lStructSize       = sizeof (OPENFILENAME) ;
     ofn.hwndOwner         = hwnd ;
     ofn.hInstance         = NULL ;
     ofn.lpstrFilter       = szFilter ;
     ofn.lpstrCustomFilter = NULL ;
     ofn.nMaxCustFilter    = 0 ;
     ofn.nFilterIndex      = 0 ;
     ofn.lpstrFile         = NULL ;          // Set in Open and Close functions
     ofn.nMaxFile          = MAX_PATH ;
     ofn.lpstrFileTitle    = NULL ;          // Set in Open and Close functions
     ofn.nMaxFileTitle     = MAX_PATH ;
     ofn.lpstrInitialDir   = NULL ;
     ofn.lpstrTitle        = ofn_title ;
     ofn.Flags             = 0 ;             // Set in Open and Close functions
     ofn.nFileOffset       = 0 ;
     ofn.nFileExtension    = 0 ;
     ofn.lpstrDefExt       = TEXT ("txt") ;
     ofn.lCustData         = 0L ;
     ofn.lpfnHook          = NULL ;
     ofn.lpTemplateName    = NULL ;
}

//-----------------------------------------------------------------------
//	

BOOL PopFileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName)
{
     ofn.hwndOwner         = hwnd ;
     ofn.lpstrFile         = pstrFileName ;
     ofn.lpstrFileTitle    = pstrTitleName ;
     ofn.Flags             = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;
     
     return GetOpenFileName (&ofn) ;
}




//-----------------------------------------------------------------------
//	

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     HDC         hdc ;
	TEXTMETRIC	tm;
	 int cxWinChar,cyWinChar;
     HACCEL       hAccel ;
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;

	 /*
	out.open(outfname,ios::in|ios::ate);
	in.open(infname);
	*/
	setappstr();

	 
	 hdc = GetDC (NULL) ; 
          GetTextMetrics (hdc, &tm) ;
          cxWinChar = tm.tmAveCharWidth ;
          cyWinChar = tm.tmHeight ;
          ReleaseDC (NULL, hdc) ;
     
     wndclass.style         = CS_HREDRAW | CS_VREDRAW  | CS_DBLCLKS;//
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (hInstance, MAKEINTRESOURCE(IDI_ICON1)) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_SIZEWE) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
     wndclass.lpszMenuName  = szMenuName ;
     wndclass.lpszClassName = szAppName ;
     
     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("error"),
                      szAppName, MB_ICONERROR) ;
          return 0 ;
     }
     
     hInst = hInstance ;
     
     hwnd = CreateWindowEx (WS_EX_OVERLAPPEDWINDOW/*WS_EX_TOPMOST*/,
							szAppName, 
                          szAppName,
                          WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_OVERLAPPEDWINDOW,
						  GetSystemMetrics(SM_CXICON),0,
                          //GetSystemMetrics(SM_CXSCREEN)-GetSystemMetrics(SM_CXMIN)-GetSystemMetrics(SM_CXSIZE)*3,0,
							GetSystemMetrics(SM_CXMIN),GetSystemMetrics(SM_CYMIN),
                          //cxWinChar*60,cyWinChar+GetSystemMetrics(SM_CYMIN)+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYHSCROLL),
                          NULL, NULL, hInstance, NULL) ;

     //ShowWindow (hwnd, iCmdShow) ;
     //UpdateWindow (hwnd) ;

    taskicon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1)) ; // ACR̃[h
    ticon.Create(hwnd,1,WM_USER_TASKBAR,taskicon,"tabasa_clip");//
    ticon.Add();

     hAccel = LoadAccelerators (hInstance, szAccelName) ;

     
     while (GetMessage (&msg, NULL, 0, 0))
     {
          if (!TranslateAccelerator (hwnd, hAccel, &msg))
          {
               TranslateMessage (&msg) ;
               DispatchMessage (&msg) ;
          }
     }
     return msg.wParam ;
}

//-----------------------------------------------------------------------
//	֐̗KōBقEEE


void OnCreateMainWin(ofstream &out,ifstream &in,HINSTANCE &hInstance,HWND hwnd, WPARAM wParam, LPARAM lParam,
				long	&index,long	&indexto,HFONT	&font,HBRUSH	&hbrushsc,HDC  &hdc,
				TEXTMETRIC &tm,int &btncxChar,int &btncyChar,int &cxWinChar,int &cyWinChar,int	&xcharhight,int	&ycharwidth,int	&scrollbarsize,long &historynow)
{
	scrollbarsize=GetSystemMetrics(SM_CYHSCROLL);
		 hbrushsc =CreateSolidBrush( GetSysColor(COLOR_ACTIVECAPTION) );//colorsc
          hdc = GetDC (hwnd) ; 
          GetTextMetrics (hdc, &tm) ;
          cxWinChar = tm.tmAveCharWidth ;
          cyWinChar = tm.tmHeight ;// + tm.tmExternalLeading
          ReleaseDC (hwnd, hdc) ;
		  xcharhight=100;
		  ycharwidth=100;
		 font=CreateFont(cyWinChar* ycharwidth/100,cxWinChar*xcharhight/100,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,("arial"));

		hwndMain=hwnd;
		
		hisflag=TRUE;
		tempoverflag=FALSE;
		setinitstr();
		init();
//		 if(ifstream init(initial))initialize(init);

		//out<<getdate(nengappi,dateform)<<mark;
		//out<<gettime(jikan,timeform)<<mark;
		 

		clipfile_close(out,in);
		clipfile_open(out,in);


		 hInstance = (HINSTANCE) GetWindowLong (hwnd, GWL_HINSTANCE) ;

          btncxChar = LOWORD (GetDialogBaseUnits ()) ;
          btncyChar = HIWORD (GetDialogBaseUnits ()) ;
          
			hwndclipreset = CreateWindow ( TEXT("button"), 
                                   clipreset,
                                   WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								   0,0,0,0,
                                   hwnd, (HMENU) idRESET,
                                   ((LPCREATESTRUCT) lParam)->hInstance, NULL) ;

			hwndButtonstarting = CreateWindow ( TEXT("button"), 
                                   starting,
                                   WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								   0,0,0,0,
                                   hwnd, (HMENU) idBUTTON,
                                   ((LPCREATESTRUCT) lParam)->hInstance, NULL) ;

			hwndButtonending = CreateWindow ( TEXT("button"), 
                                   ending,
                                   WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								   0,0,0,0,
                                   hwnd, (HMENU) idBUTTONEND,
                                   ((LPCREATESTRUCT) lParam)->hInstance, NULL) ;

          hwndEdit = CreateWindow (TEXT ("edit"), szEditTitleName,
                           WS_CHILD | WS_VISIBLE |WS_HSCROLL | WS_VSCROLL |
                                   WS_BORDER | ES_LEFT | ES_MULTILINE |
                                   ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                         hwnd, NULL, hInstance,NULL) ;


          hwndSearch = CreateWindow (TEXT ("edit"), szSearchTitleName,
                           WS_CHILD | WS_VISIBLE |WS_HSCROLL | WS_VSCROLL |
                                   WS_BORDER | ES_LEFT | ES_MULTILINE |
                                   ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                        hwnd, NULL, hInstance,NULL) ;


               hwndScroll = CreateWindow (TEXT ("scrollbar"), NULL,
                                             WS_CHILD | WS_VISIBLE | 
                                             WS_TABSTOP | SBS_HORZ,
                                             0, 0, 0, 0, 
                                             hwnd, (HMENU) idSCROLL, hInstance, NULL) ;
               
               SetScrollRange (hwndScroll, SB_CTL, 1, indexmax, FALSE) ;
               SetScrollPos   (hwndScroll, SB_CTL, indexmax, FALSE) ;

               OldEdit = (WNDPROC) SetWindowLong (hwndEdit, 
                                             GWL_WNDPROC, (LONG) EditProc) ;
               OldSearch = (WNDPROC) SetWindowLong (hwndSearch, 
                                             GWL_WNDPROC, (LONG) SearchProc) ;
               OldScroll = (WNDPROC) SetWindowLong (hwndScroll, 
                                             GWL_WNDPROC, (LONG) ScrollProc) ;
		  countmax(infname,indexto);
	if((strcmp(infname,outfname)==0) && (indexmax > INDEXMAX+INDEXMIN))
		{
			index=0;
			onindexmax(out,in,index);
			indexmax -= INDEXMAX;
		}
		  index=indexmax+1;
			hMainMenu=GetMenu(hwnd);
			hClipMenu=GetSubMenu(hMainMenu,CLIPMENU_POS);
			hMenu=GetSubMenu(hClipMenu,0);
			hRecycleMenu=GetSubMenu(hClipMenu,RECYCLEMENU_POS);
			hSpMenu=GetSubMenu(hClipMenu,SPECIALMENU_POS);
			setSpFname();
			for(int m=0;m<10;m++)
			{
				hSpecialMenu[m]=GetSubMenu(hSpMenu,m);
				initialspecial(hSpecialMenu[m],index,m);
			}
			hTempClipMenu=GetSubMenu(hClipMenu,TEMPCLIPMENU_POS);
			hSpFnameMenu=GetSubMenu(hClipMenu,SPFNAMEMENU_POS);
			//hTempClipMenu=GetSubMenu(hTempClipMenu,1);
			initialhistory(hMenu,infname,index,historynow);
			initialrecycle(hRecycleMenu,index);
			initialtmpclip(hTempClipMenu,tmpclipsavefile);
			initsp();
			CheckSpFname();
			index=indexmax+1;
			historyon(hisflag);
			pop.setmode(ADD_POPUP);
			//SendMessage (hwnd, WM_LBUTTONDOWN, wParam, lParam) ;
	 SetWindowText(hwndSearch,"");
     hwndNextViewer = SetClipboardViewer (hwnd) ;
}


void addcliphistory(char *buff)
{
	out<<buff<<mark;
	indexmax++;
	index=indexmax;
	menuplus(hMenu,IDM_HISTORYBASE,index,buff,HISTORYMAX,historynow);
}


//..................................................................
//
// ^XNgC ...

void	mousetaskbar(LPARAM lParam)
{
        // ENbNƂA|bvAbvj[\
        if(lParam == WM_RBUTTONDOWN)//
		{
            SetForegroundWindow(hwndMain);
			SendMessage (hwndMain, WM_NCMOUSEMOVE, WM_USER_TASKBAR, 0) ;
		}
		// NbNƂAf[^𗚗ɒǉ
        if(lParam == WM_LBUTTONDOWN)
		{
			if(buff[0]!=0)
			{
				addcliphistory(buff);
			}
		}
        if(lParam == WM_LBUTTONDBLCLK)
		{
			//ShowWindow(hwndMain,SW_SHOW);
			  
		}
}


//-----------------------------------------------------------------------
//	

LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static POINT	ppopup;//,pback
     HDC         hdc ;
	TEXTMETRIC	tm;
	static WINDOWPLACEMENT	wp;
	static int	mode=AUTO;
	static HBRUSH	hbrushsc;//	=CreateSolidBrush(colorsc);
	static HFONT	font;
	static	int	xcharhight,ycharwidth;
     PTSTR       pGlobal ;
     BOOL         bEnable ;
     PAINTSTRUCT ps ;
     RECT        rect ;
     static PTSTR pText ;

     static CHOOSECOLOR cc ;
     static COLORREF    crCustColors[16] ;
	 static int editwindow=0;
	char etitle[100];

     cc.lStructSize    = sizeof (CHOOSECOLOR) ;
     cc.hwndOwner      = hwnd ;
     cc.hInstance      = NULL ;
     cc.rgbResult      = RGB (0x80, 0x80, 0x80) ;
     cc.lpCustColors   = crCustColors ;
     cc.Flags          = CC_RGBINIT | CC_FULLOPEN ;
     cc.lCustData      = 0 ;
     cc.lpfnHook       = NULL ;
     cc.lpTemplateName = NULL ;


	static char titlename[namemax];
	static  long	oindex=1;
	static  long	indexto=1;
	static  long	indexs[]={1,1,1,1,1,1,1,1,1,1,
								1,1,1,1,1,1,1,1,1,1};// \
	static int indexnum=0;
	const int historymax=19;
	static int sflag=SUSUMU;
	char textbuff[buffmax*2];//K
	static  HINSTANCE      hInstance ;
     int             cxClient, cyClient ;
     static  long     color=1, cyChar ;
	 static  int scrollbarsize;

	 static int btncxChar,btncyChar,cxWinChar,cyWinChar;
	// static CTaskbarIcon ticon;


		//countmax(infname,indexto);


     switch (message)
     {
     case WM_CREATE:
		historynow=0;
		index=1;
		 wp.length=sizeof(WINDOWPLACEMENT);
		 OnCreateMainWin(out,in,hInstance,hwnd, wParam, lParam,
				index,indexto,font,hbrushsc,hdc,
				tm,btncxChar,btncyChar,cxWinChar,cyWinChar,xcharhight,ycharwidth,scrollbarsize,historynow);



		 return 0 ;
          
     case WM_SIZE : 
          cxClient = LOWORD (lParam) ;
          cyClient = HIWORD (lParam) ;
		MoveWindow (hwndScroll,
                           0, 0,
                           cxClient, scrollbarsize,  TRUE) ;//cyClient
		 MoveWindow (hwndButtonstarting, cxClient-10 * btncxChar, scrollbarsize,
                          10 * btncxChar, 7 * btncyChar / 4, TRUE) ;
		 MoveWindow (hwndButtonending, cxClient-10 * btncxChar, scrollbarsize+ 7 * btncyChar / 4,
                          10 * btncxChar, 7 * btncyChar / 4, TRUE) ;
		 MoveWindow (hwndclipreset, cxClient-10 * btncxChar, scrollbarsize+ (7 * btncyChar / 4)*2,
                          10 * btncxChar, 7 * btncyChar / 4, TRUE) ;

		 MoveWindow (hwndEdit, 0, cyWinChar* ycharwidth/100+scrollbarsize,
                           cxClient-10 * btncxChar, cyClient-cyClient/5-cyWinChar* ycharwidth/100-scrollbarsize, TRUE) ;
		 MoveWindow (hwndSearch, 0, cyClient-cyClient/5,
                           cxClient-10 * btncxChar, cyClient/5, TRUE) ;

          return 0 ;
          
    case WM_USER_TASKBAR:
		mousetaskbar(lParam);
        break;

     case WM_SETFOCUS :
          SetFocus (hwndScroll) ;
          return 0 ;
          
     case WM_HSCROLL :
          //  SetScrollRange (hwndScroll, SB_CTL, 0, indexmax, FALSE) ; 
          GetWindowLong ((HWND) lParam, GWL_ID) ;

          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               color += 15 ;
                                             // fall through
          case SB_LINEDOWN :
               color = min (indexmax, color + 1) ;
               break ;
               
          case SB_PAGEUP :
               color -= 15 ;
                                             // fall through
          case SB_LINEUP :
               color = max (1, color - 1) ;
               break ;
               
          case SB_TOP :
               color = 1 ;
               break ;
               
          case SB_BOTTOM :
               color = indexmax ;
               break ;
               
          case SB_THUMBPOSITION :
               SendMessage (hwnd, WM_KEYUP, wParam, lParam) ;
          case SB_THUMBTRACK :
               color = HIWORD (wParam) ;
               break ;
               
          case SB_ENDSCROLL:
               SendMessage (hwnd, WM_KEYUP, wParam, lParam) ;

               break ;
               

          default :
               break ;
          }
          //SetScrollPos  (hwndScroll, SB_CTL, color, TRUE) ;
		  index = color+1;
			SendMessage (hwnd, WM_LBUTTONDOWN, LDOWN, lParam) ;
           
         // InvalidateRect (hwnd, NULL, TRUE) ;
          return 0 ;
          
    case WM_INITMENUPOPUP:
          //EnableMenuItem ((HMENU) wParam, IDM_EDIT_PASTE,
           //    IsClipboardFormatAvailable (clipformat) ? MF_ENABLED : MF_GRAYED) ;

          EnableMenuItem ((HMENU) wParam, IDM_Fopen, MF_ENABLED  ) ;
          bEnable = pText ? MF_ENABLED : MF_GRAYED ;

          EnableMenuItem ((HMENU) wParam, IDM_EDIT_CUT,   bEnable) ;
          EnableMenuItem ((HMENU) wParam, IDM_EDIT_COPY,  bEnable) ;
          EnableMenuItem ((HMENU) wParam, IDM_EDIT_CLEAR, bEnable) ;
          return 0 ;
          
     case WM_COMMAND:

          switch (LOWORD (wParam))
          {
			case IDD_hp:
				CreateDialog(hInst,MAKEINTRESOURCE(IDD_aboutme),hwnd,(int (__stdcall *)(void))about1);
				//dialogbox(IDD_about);
			 	return 0 ;


          case idRESET:
			  setclip(hwnd,flagstart,flagend);
		       return 0 ;

          case idBUTTON:
			switch (HIWORD (wParam))
			 {
			 case BN_CLICKED:
				sandwitch(hwndButtonstarting,hwndstarted,starting,starton,startMenuName,flagstart);
				return 0 ;
			 }
          return 0 ;

          case idBUTTONEND:
			switch (HIWORD (wParam))
			 {
			 case BN_CLICKED:
				sandwitch(hwndButtonending,hwndended,ending,endon,endMenuName,flagend);
				break;
			 }
          return 0 ;



          case IDM_Fopen:
			clipfile_close(out,in);
			PopFileInitialize (hwnd);
			if(PopFileOpenDlg (hwnd,pathname,titlename))
				strcpy(infname,pathname);
			clipfile_open(out,in);
			index=1;
			indexmax=0;
			SendMessage (hwnd, WM_LBUTTONDOWN, wParam, lParam) ;
          return 0 ;

		  //pop up menu Zbg
          case IDM_MENU_RESET:
			  //InsertMenu(hSpFnameMenu,);
			  break;
          case IDM_TAG_LINK:
			  setcliptaglink();
			  break;
		  //pop up menu ؂ւ
          case IDM_TEMP_POPUP:
			  pop.setmode(TEMP_POPUP);
			  break;
          case IDM_ADD_POPUP:
			  pop.setmode(ADD_POPUP);
			  break;
          case IDM_ALL_POPUP:
			  pop.setmode(ALL_POPUP);
			  break;
          case IDM_SP_POPUP:
			  pop.setmode(SP_POPUP);
			  break;

          case IDM_EDIT_CUT:
          case IDM_EDIT_COPY:

                    return 0 ;        
                                             // fall through for IDM_EDIT_CUT
          case IDM_EDIT_CLEAR:
               return 0 ;

          case IDM_EDIT_RESET:
			SendMessage (hwnd, WM_DESTROY, wParam, lParam) ;
               return 0 ;

		  case ID_PLUSTOP:
			  getindex(index,indexs,historymax);
			  getindex(index,indexs,historymax);
			index++;
			SendMessage (hwnd, WM_LBUTTONDOWN, wParam, lParam) ;
				return 0 ;

		  case ID_PLUSTAIL:
				return 0 ;

		  case IDM_COLOR:
				return 0 ;

		  case IDM_HELP:
			 system("notepad readme.txt");
			return 0 ;

		  case IDM_FOLDER:
			 WinExec("explorer .",SW_SHOW);//system("explorer .");
			return 0 ;

		  case IDM_NOTEPAD:
			 WinExec("notepad",SW_SHOW);
			return 0 ;

		  case IDM_FONT_BIG:
		  xcharhight=xcharhight+20;
		  ycharwidth=ycharwidth+20; 
		 font=CreateFont(cyWinChar* ycharwidth/100,cxWinChar*xcharhight/100,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,("arial"));
        InvalidateRect (hwnd, NULL, TRUE) ;
			return 0 ;

		  case IDM_FONT_SMALL:
		  xcharhight=max(10,xcharhight-20);
		  ycharwidth=max(10,ycharwidth-20); 
		 font=CreateFont(cyWinChar* ycharwidth/100,cxWinChar*xcharhight/100,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,("arial"));
        InvalidateRect (hwnd, NULL, TRUE) ;
			return 0 ;

		  case IDM_FONT_RESET:
		  xcharhight=100;
		  ycharwidth=100; 
		 font=CreateFont(cyWinChar* ycharwidth/100,cxWinChar*xcharhight/100,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,("arial"));
        InvalidateRect (hwnd, NULL, TRUE) ;
			return 0 ;


		  case IDM_RESET:
			  OnChangefile(hwnd, wParam, lParam,out,in,defaultname,defaultname,outfname,infname,index);
			 font=CreateFont(cyWinChar,cxWinChar,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,("arial"));

          return 0 ;

		  case IDM_SPECIAL:
			  OnChangefile(hwnd, wParam, lParam,out,in,defaultname,specialfname[specialfnum],outfname,infname,index);
          return 0 ;



		  case IDM_RECYCLE:
			  OnChangefile(hwnd, wParam, lParam,out,in,defaultname,recyclefname,outfname,infname,index);
          return 0 ;

		  case IDM_win:
			  ShowWindow(hwnd,SW_NORMAL);
			  return 0 ;

		  case IDM_task:
			  ShowWindow(hwnd,SW_HIDE);
			  return 0 ;

		  case IDM_his_off:
			  historyon(FALSE);
			  return 0 ;

		  case IDM_his_on:
			  historyon(TRUE);
			  return 0 ;

		case IDM_DO_SEARCH://do.search()
			  onsearch(out,in,index,hwndSearch);
			SendMessage (hwnd, WM_KEYUP, wParam, lParam) ;
         	return 0 ;

		case IDM_DATE://
			getdate(buff,dateform);
			SendMessage (hwnd, WM_KEYUP, wParam, lParam) ;
         	return 0 ;

		case IDM_TIME_NOW://
			gettime(buff,timeform);
			SendMessage (hwnd, WM_KEYUP, wParam, lParam) ;
         	return 0 ;

		case IDD_DIALOG1:
			CreateDialog(hInst,MAKEINTRESOURCE(IDD_aboutme),hwnd,(int (__stdcall *)(void))about1);
			//dialogbox(IDD_about);
         	return 0 ;

		case IDM_MENU_PLUS:
			onclipmenuplus();
         	return 0 ;
		case IDM_TRANS_TO_MAIL:
			GetWindowText(hwndEdit,buff,buffmax);
			decode(buff,buff_mail);
			SetWindowText(hwndEdit,buff_mail);
         	return 0 ;
		case IDM_TRANS_SJIS:
			GetWindowText(hwndEdit,buff,buffmax);
			MyJisToSJis(buff,buff_mail);
			SetWindowText(hwndEdit,buff_mail);
         	return 0 ;
		case IDM_TRANS_JIS:
			GetWindowText(hwndEdit,buff,buffmax);
			MySJisToJis(buff,buff_mail);
			SetWindowText(hwndEdit,buff_mail);
         	return 0 ;
		case IDM_sp_edit:
			DialogBox(hInst, "SPDLG", hwnd, (DLGPROC)SpDlgProc);
         	return 0 ;

		case IDM_OPEN_NOTE://open.note(j
			  editwindow++;
			  sprintf(etitle,"%d:",editwindow);
          hwndEditE=CreateWindow (TEXT ("edit"), etitle,
						WS_VISIBLE | WS_HSCROLL | WS_VSCROLL |
                         WS_BORDER | ES_LEFT | ES_MULTILINE |
                         ES_AUTOHSCROLL | ES_AUTOVSCROLL | 
                          WS_CLIPSIBLINGS|WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, LoadMenu(hInst,szEditMenuName), hInstance, NULL) ;
               OldEditE = (WNDPROC) SetWindowLong (hwndEditE, 
                                             GWL_WNDPROC, (LONG) EditEProc) ;
		SetWindowText(hwndEditE,"");

         	return 0 ;

		 }
		 if(LOWORD (wParam)>IDM_HISTORYBASE && LOWORD (wParam)<HISTORYADDMAX+IDM_HISTORYBASE)
			{
			 index=(LOWORD (wParam)-IDM_HISTORYBASE)+1;
			 SendMessage (hwnd, WM_LBUTTONDOWN, NULL, lParam) ;
			 SendMessage (hwnd, WM_LBUTTONUP, NULL, lParam) ;
			 outrecycle(index);
			 }
		 if(LOWORD (wParam)>IDM_RECYCLEBASE && LOWORD (wParam)<HISTORYADDMAX+IDM_RECYCLEBASE)
			{
			 index=(LOWORD (wParam)-IDM_RECYCLEBASE)+1;
			 SendMessage (hwnd, WM_LBUTTONDOWN, NULL, lParam) ;
			 SendMessage (hwnd, WM_LBUTTONUP, NULL, lParam) ;
			 }
		 if(LOWORD (wParam)>IDM_SPECIALBASE && LOWORD (wParam)<SPECIALADDMAX*10+IDM_SPECIALBASE)
			{
			 long num=(LOWORD (wParam)-IDM_SPECIALBASE)%SPECIALADDMAX;//܂
			 int fnum=(LOWORD (wParam)-IDM_SPECIALBASE-num)/SPECIALADDMAX;
			 setclipfromfile(specialfname[specialfnum],fnum,num,titlemax);
			 }
		 if(LOWORD (wParam)>=IDM_SpFnameBASE && LOWORD (wParam)<=SpFnameMAX+IDM_SpFnameBASE)
		 {
			 CheckSpFname(LOWORD (wParam) -IDM_SpFnameBASE );
		 }
		 if(LOWORD (wParam)>=IDM_TEMPCLIPBASE && LOWORD (wParam)<=TEMPCLIPMAX+IDM_TEMPCLIPBASE)
			{
			 //ɂǉ
			 strcpy(buff,tempclip.getbyid(LOWORD (wParam)));
			 if ( hisflag==FALSE ) addcliphistory(buff);
			 setclip(hwnd,flagstart,flagend);
			 }
		if(LOWORD (wParam)>=IDM_TO_SPECIALF && LOWORD (wParam)<IDM_TO_SPECIALF+10)//to.special(ʂɁj
			{
			int m=LOWORD (wParam)-IDM_TO_SPECIALF;
			long i=GetMenuItemCount(hSpecialMenu[m]);
				outspecial(i,buff,m);
				SetFocus (hwndScroll) ;
			}	
		if(LOWORD (wParam)>=IDM_SPECIAL_CHANGE && LOWORD (wParam)<=IDM_SPECIAL_CHANGE+specialfnummax)
			{
			int fnum=LOWORD (wParam)-IDM_SPECIAL_CHANGE;
			CheckSpecial(fnum);
			}	
         return 0 ;

     case WM_CHANGECBCHAIN:
          if ((HWND) wParam == hwndNextViewer)
               hwndNextViewer = (HWND) lParam ;
          
          else if (hwndNextViewer)
               SendMessage (hwndNextViewer, message, wParam, lParam) ;
          
          return 0 ;
          
     case WM_DRAWCLIPBOARD:
		 onDrawclipboard(message, wParam, lParam,hwnd,rect,pGlobal,out,in,titlename,titlemax,historynow,index);

		 ticon.SetTip(buff,TRUE);//
		return 0 ;

          
	case WM_KEYUP:
    case WM_LBUTTONUP:
    case WM_RBUTTONUP:
		SetFocus (hwndScroll) ;
		setclip(hwnd,flagstart,flagend);
		setindex(index,indexs,historymax);

          return 0 ;
/*          
     case WM_MOUSEMOVE : //ʂ̍}EXƂ
			if(LOWORD (lParam)<GetSystemMetrics(SM_CYMIN)*3)
				TrackPopupMenu(GetSubMenu(GetMenu(hwnd),1),TPM_RIGHTBUTTON,0,0,0,hwnd,NULL);

          return 0 ;
*/


     case WM_NCMOUSEMOVE :
		 //^Cgo[̍ACR}EXƂ
		 if(wParam==HTSYSMENU)
		 {
			ppopup.x=0;
			ppopup.y=0;
			TrackPopupMenu(pop.menu,TPM_RIGHTBUTTON,ppopup.x,ppopup.y,0,hwnd,NULL);
		 }
		 //^XNo[̉ENbN
		 if(wParam==WM_USER_TASKBAR)
		 {
            POINT point;
            GetCursorPos(&point);
			TrackPopupMenu(pop.menu,TPM_RIGHTBUTTON,point.x,point.y,0,hwnd,NULL);
		 }



          return 0 ;
    

	case	WM_CHAR:
		if(wParam==FILECH)//	
		{
			SendMessage (hwnd, WM_COMMAND, IDM_Fopen, lParam) ;
			return 0 ;
		}
		if(wParam==LDOWN || wParam==LDOWNS)//	<
		{
			SendMessage (hwnd, WM_LBUTTONDOWN, wParam, lParam) ;
			return 0 ;
		}
		if(wParam==RDOWN || wParam==RDOWNS)//	>
		{
			SendMessage (hwnd, WM_RBUTTONDOWN, wParam, lParam) ;
			return 0 ;
		}
		 if (in.eof())
		 {
			index=0;
			clipfile_close(out,in);
			clipfile_open(out,in);
		 }
		 do
		 {
			readdata(in,index);
		 }
		 while(wParam!=buff[0] && !in.eof());
		 if (in.eof())
		 {
			clipfile_close(out,in);
			clipfile_open(out,in);
			index=0;
		 }
          InvalidateRect (hwnd, NULL, TRUE) ;
          return 0 ;  

     case WM_PAINT:
         SetScrollRange (hwndScroll, SB_CTL, 1, indexmax, TRUE) ;
		 SetScrollPos   (hwndScroll, SB_CTL, index, TRUE) ;
          hdc = BeginPaint (hwnd, &ps) ;
		  SelectObject(hdc,font);
          GetClientRect (hwnd, &rect) ;

		  sprintf(textbuff,titleform,infname,index,indexmax,strlen(buff),INDEXMAX,INDEXMIN,HISTORYMAX);
          //DrawText (hdc, textbuff, -1, &rect, DT_EXPANDTABS) ;
		  TextOut (hdc, 0,scrollbarsize,textbuff,strlen(textbuff));
		settitle(hwnd,titlename,buff,titlemax);//^Cgo[ɕ\
		  

          EndPaint (hwnd, &ps) ;
          return 0 ;
          
     case WM_LBUTTONDOWN:
		sflag=MODORU;
		indexto=index-1;
		if(wParam==LDOWNS)indexto=index-100 ;	//100߂
		if(indexto<1)indexto=indexmax;
		clipfile_close(out,in);
		clipfile_open(out,in);
		index=0;
		searchclip(sflag,out,in,index,indexto, pText,pGlobal,hwnd);
		SetWindowText(hwndEdit,buff);

          InvalidateRect (hwnd, NULL, TRUE) ;
		  return 0 ; 

 
	 case WM_NCHITTEST:
		 break; 


     case WM_RBUTTONDOWN:
		sflag=SUSUMU;
		indexto=1 ;
		if(wParam==RDOWNS)indexto=100 ;	//100i
		searchclip(sflag,out,in,index,indexto, pText,pGlobal,hwnd);
		if(in.eof())
		{
			clipfile_close(out,in);
			clipfile_open(out,in);
			index=0;
			searchclip(sflag,out,in,index,indexto, pText,pGlobal,hwnd);

		}
        InvalidateRect (hwnd, NULL, TRUE) ;
       return 0 ;      


	   /*
     case WM_LBUTTONDBLCLK:
			  ShowWindow(hwnd,SW_NORMAL);
          return 0 ;
     case WM_RBUTTONDBLCLK:
			SendMessage (hwnd, WM_RBUTTONDOWN, RDOWNS, lParam) ;
          return 0 ;

*/
     case WM_CTLCOLORSCROLLBAR:
		return	(LRESULT)hbrushsc;

     case WM_DESTROY:
		 ondestroyclip(out,in,index);
		 tempclip.savetmp();
		 DeleteObject(hbrushsc);
		 DeleteObject(font);
          ChangeClipboardChain (hwnd, hwndNextViewer) ;
		  ticon.Delete();

          PostQuitMessage (0) ;
          return 0 ;
     }
     return DefWindowProc (hwnd, message, wParam, lParam) ;
}




LRESULT CALLBACK SpDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static HWND hEdit,hFname,hBlock,hFnum,hIndex;
	static int block,fnum;
	static long index;
	char buffer[MAX_PATH];

    switch (msg) {
        case WM_INITDIALOG:
			index=0;
			block=0;
			fnum=0;
            hEdit = GetDlgItem(hDlg, IDC_SP_EDIT);
            hBlock = GetDlgItem(hDlg, IDC_block);
            hFnum = GetDlgItem(hDlg, IDC_fnum);
            hFname = GetDlgItem(hDlg, IDC_fname);
            hIndex = GetDlgItem(hDlg, IDC_index);
			//getSpClipData(fnum,n);
			SendMessage(hDlg,WM_COMMAND,IDC_next,0);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDC_paste:
					/*
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					deleteSpClipData(fnum,index);*/
                    return TRUE;
                case IDC_delete:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					deleteSpClipData(fnum,index);
                    return TRUE;
                case IDC_save:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					Edit_GetText(hEdit, buff, buffmax);
					putSpClipData(block,fnum,buff);
                    return TRUE;
                case IDC_reload:
					getSpClipData(block,fnum,index);
					Edit_SetText(hEdit, buff, buffmax);
					Edit_SetText(hFname, spfnamebase, buffmax);
					sprintf(buffer,"%d",block);
					Edit_SetText(hBlock, buffer, 10);
					sprintf(buffer,"%d",fnum);
					Edit_SetText(hFnum, buffer, 10);
					sprintf(buffer,"%d",index);
					Edit_SetText(hIndex, buffer, 10);
                    return TRUE;
                case IDC_next:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					index++;
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_next_h:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					fnum++;
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_next_b:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					block++;
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_before:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					if(index>0) index--;
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_before_h:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					if(fnum>0) fnum--;
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_before_b:
					Edit_GetText(hFnum, buffer, 10);
					sscanf(buffer,"%d",&fnum);
					Edit_GetText(hBlock, buffer, 10);
					sscanf(buffer,"%d",&block);
					if(block>0) block--;
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_fname_ch:
					nextspfname();
					SendMessage(hDlg,WM_COMMAND,IDC_reload,0);
                    return TRUE;
                case IDC_fnamesave:
					Edit_GetText(hFname, buffer, MAX_PATH);
					addspfname(buffer);
					setSpFname(buffer);
                    return TRUE;
                case IDOK:
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}


