#include "defextern.h"

#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include <commdlg.h>
#include <list>
#include "resource.h"
//#include "lang.h"
#include "tabasa.h"


//--------------------------------------

BOOL CALLBACK about1 (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
     switch (message)
     {
     case WM_COMMAND:

		switch (LOWORD (wParam))
		{
			case IDOK:
			default:
				return FALSE;


			 case IDCANCEL:
				DestroyWindow(hwnd);

				return FALSE;
		}
	}

          
	return FALSE;
}

//-----------------------------------------------------------------------
//	XN[o[(Nbv{[hAj

LRESULT CALLBACK ScrollProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
     int id = GetWindowLong (hwnd, GWL_ID) ;
	HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
          
	
     switch (message)
     {

     case WM_MOUSEMOVE : 
		 //SendMessage (hwndMain, message, wParam, lParam) ;
          break ;

     case WM_KEYDOWN :
          if (wParam == VK_TAB)
               SetFocus (GetDlgItem (GetParent (hwnd), 
                    (id + (GetKeyState (VK_SHIFT) < 0 ? 2 : 1)) % 3)) ;
          break ;
	case WM_CHAR:
	case WM_KEYUP:
          SendMessage (wparent, message, wParam, lParam) ;
		break ;  
          
     }
     return CallWindowProc ((FARPROC) OldScroll, hwnd, message, wParam, lParam) ;
}

//-----------------------------------------------------------------------
//	GfB^
//

LRESULT CALLBACK EditEProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
     int id = GetWindowLong (hwnd, GWL_ID) ;
	HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
	char buffer[buffmax];
          
	
     switch (message)
     {
     case WM_COMMAND:

          switch (LOWORD (wParam))
		{
			
			case IDM_SEND:
					
				GetWindowText(hwnd,buff,buffmax);
				setclip(hwnd,flagstart,flagend);
				break ;     

			case IDM_EDIT_COPY:
				SetWindowText(hwnd,buff);
				break ;     

			case IDM_EDIT_CLEAR:
				SetWindowText(hwnd,"");
				break ;     

			case IDM_SET_SEARCH:
				GetWindowText(hwnd,buffer,buffmax);
				SetWindowText(hwndSearch,buffer);
				ShowWindow (hwndMain, SW_RESTORE) ;
				SetFocus (hwndMain) ;
				break ;     

		case IDM_OPEN_NOTE://open.note(j
			SendMessage (hwndMain, WM_COMMAND, wParam, lParam) ;
				break ;     

		case IDM_MAIN:
				ShowWindow (hwndMain, SW_RESTORE) ;
				SetFocus (hwndMain) ;
			return 0 ;

		case IDM_TO_SPECIAL:
			GetWindowText(hwnd,buffer,buffmax);
			outspecial(0,buffer,0);
			return 0 ;
		}
     }
     return CallWindowProc ((FARPROC) OldEditE, hwnd, message, wParam, lParam) ;
}


//-----------------------------------------------------------------------
//	Nbv{[hAҏW

LRESULT CALLBACK EditProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
     int id = GetWindowLong (hwnd, GWL_ID) ;
	HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
          
	
     switch (message)
     {



	case WM_KILLFOCUS:
		GetWindowText(hwndEdit,buff,buffmax);
		setclip(hwndEdit,flagstart,flagend);
		break ;     
     }
     return CallWindowProc ((FARPROC) OldEdit, hwnd, message, wParam, lParam) ;
}


//-----------------------------------------------------------------------
//	ҏW

LRESULT CALLBACK SearchProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
     int id = GetWindowLong (hwnd, GWL_ID) ;
	HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
          
	
     switch (message)
     {



	case WM_KILLFOCUS:
		break ;     
     }
     return CallWindowProc ((FARPROC) OldSearch, hwnd, message, wParam, lParam) ;
}



