#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include <mbstring.h>
#include <fstream.h>
#include "jis.h"
//#include "initial.h"
//#include "file.h"
//#include "statusbar.h"
//#include "file.h"
//#include "buffer.h"

/*
void transRNmail(char *file)
{
	char fnew[MAX_PATH];
	char *p;
	char *buf=szStrRcv;
	int count=0;
	makenewfilename(file,fnew,"$$$");
	ifstream in(file);
	ofstream ou(fnew);
	if(!ou) return;
	while(1)
	{
		in.get(buf[0]);
		if(in.gcount()==0) break;
		if(buf[0]=='\r') count++;
		else ou.put(buf[0]);
		in.get(buf,MAX_RCV,'\r');
		ou.write(buf,in.gcount());
		if(in.eof()) break;
	}
	in.close();
	ou.close();
	remove(file);
	rename(fnew,file);
	setstatus("sϊ", count);
}
*/

char charconv(char c)
{
    char str[256];

    if (c >= 'A' && c <= 'Z')
        return (c - 'A');
    if (c >= 'a' && c <= 'z')
        return (c - 'a' + 0x1a);
    if (c >= '0' && c <= '9')
        return (c - '0' + 0x34);
    if (c == '+')
        return 0x3e;
    if (c == '/')
        return 0x3f;
    if (c == '=')
        return '\0';
    
    return '\0';
}


void decode(char *lpszStr, char *lpszResult)
{
    int len, i, iR;
    char a1, a2, a3, a4;

    len = strlen(lpszStr);
    i = 0;
    iR = 0;
    while (1) {
        if (i >= len)
            break;
        a1 = charconv(lpszStr[i]);
        a2 = charconv(lpszStr[i+1]);
        a3 = charconv(lpszStr[i+2]);
        a4 = charconv(lpszStr[i+3]);
        lpszResult[iR] = (a1 << 2) + (a2 >>4);
        lpszResult[iR + 1] = (a2 << 4) + (a3 >>2);
        lpszResult[iR + 2] = (a3 << 6) + a4;
        i += 4;
        iR += 3;
    }
    return;
}

void MyJisToSJis(char *lpOrg, char *lpDest)
{
    int i = 0, iR = 0, c;
    BOOL bSTART = FALSE;//JIS->SJISϊKvǂ

    while (1) {
        if (lpOrg[i] == 0x1b && lpOrg[i + 1] == 0x24 && (lpOrg[i + 2] == 0x42 || lpOrg[i + 2] == 0x40) ){
            bSTART = TRUE;
            i += 3;
            continue;
        }
        if (lpOrg[i] == 0x1b && lpOrg[i+ 1] == 0x28 && (lpOrg[i + 2] == 0x42 || lpOrg[i + 2] == 0x4a )) {
            bSTART = FALSE;
            i += 3;
            continue;
        }
        if (lpOrg[i] >= 0x21 && lpOrg[i] <= 0x7e && bSTART) {
            c = MAKEWORD(lpOrg[i + 1], lpOrg[i]);
            lpDest[iR] = (char)HIBYTE(_mbcjistojms(c));
            lpDest[iR + 1] = (char)LOBYTE(_mbcjistojms(c));
            i += 2;
            iR += 2;
            continue;
        }
        if (i == 0 && lpOrg[0] == '\n') {
            lpDest[iR] = '\r';
            lpDest[iR + 1] = '\n';
            i++;
            iR += 2;
            continue;
        }
        if (lpOrg[i] == '\n' && lpOrg[i - 1] != '\r') {
            lpDest[iR] = '\r';
            lpDest[iR + 1] = '\n';
            i++;
            iR += 2;
            continue;
        }
        if (lpOrg[i] == '\0') {
            lpDest[iR] = lpOrg[i];
            break;
        }
        lpDest[iR] = lpOrg[i];
        iR++;
        i++;
    }
	//setstatus("jistosjis");
    return;
}

void encode(char *lpszOrg, char *lpszDest,BOOL add)
{
    int i = 0, iR = 16;

    if(add) strcpy(lpszDest, "=?ISO-2022-JP?B?");
	else iR=0;

    while (1) {
        if (lpszOrg[i] == '\0') {
            break;
        }
        lpszDest[iR] = convtobase((lpszOrg[i]) >> 2);
        if (lpszOrg[i + 1] == '\0') {
            lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) );
            lpszDest[iR + 2] = '=';
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 1] = convtobase(((lpszOrg[i] & 0x3) << 4) + ((lpszOrg[i + 1]) >> 4));
        if (lpszOrg[i + 2] == '\0') {
            lpszDest[iR + 2] = convtobase((lpszOrg[i + 1] & 0xf) << 2);
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 2] = convtobase(((lpszOrg[i + 1] & 0xf) << 2) + ((lpszOrg[i + 2]) >> 6));
        lpszDest[iR + 3] = convtobase(lpszOrg[i + 2] & 0x3f);
        lpszDest[iR + 4] = '\0';
        i += 3;
        iR += 4;
    }
    if(add) strcat(lpszDest, "?=");
    return;
}



void MySJisToJis(char *lpszOrg, char *lpszDest)
{
    int i = 0, iR = 0, c;
    BOOL bSTART = FALSE;

    while (1) {
        if (_ismbblead(lpszOrg[i]) && bSTART == FALSE) {
            lpszDest[iR] = 0x1b;
            lpszDest[iR + 1] = 0x24;
            lpszDest[iR + 2] = 0x42;
            c = MAKEWORD(lpszOrg[i + 1], lpszOrg[i]);
            lpszDest[iR + 3] = (char)HIBYTE(_mbcjmstojis(c));
            lpszDest[iR + 4] = (char)LOBYTE(_mbcjmstojis(c));
            bSTART = TRUE;
            i += 2;
            iR += 5;
            if (!_ismbblead(lpszOrg[i])) {
                lpszDest[iR] = 0x1b;
                lpszDest[iR + 1] = 0x28;
                lpszDest[iR + 2] = 0x42;
                bSTART = FALSE;
                iR += 3;
            }
            continue;
        }
        if (_ismbblead(lpszOrg[i]) && bSTART) {
            c = MAKEWORD(lpszOrg[i + 1], lpszOrg[i]);
            lpszDest[iR] = (char)HIBYTE(_mbcjmstojis(c));
            lpszDest[iR + 1] = (char)LOBYTE(_mbcjmstojis(c));
            i += 2;
            iR += 2;
            if (!_ismbblead(lpszOrg[i])) {
                lpszDest[iR] = 0x1b;
                lpszDest[iR + 1] = 0x28;
                lpszDest[iR + 2] = 0x42;
                bSTART = FALSE;
                iR += 3;
            }
            continue;
        }
        if (lpszOrg[i] == '\r') {
            lpszDest[iR] = '\n';
            i += 2;
            iR++;
            continue;
        }
        if (lpszOrg[i] == '\0') {
            lpszDest[iR] = lpszOrg[i];
            break;
        }
        lpszDest[iR] = lpszOrg[i];
        iR++;
        i++;
    }
    return;
}



char convtobase(char c)
{
    if (c <= 0x19)
        return c + 'A';
    if (c >= 0x1a && c <= 0x33)
        return c - 0x1a + 'a';
    if (c >= 0x34 && c <= 0x3d)
        return c - 0x34 + '0';
    if (c == 0x3e)
        return '+';
    if (c == 0x3f)
        return '/';
    return '=';
}

/*
void convertfileformail(char *afile,char *tfile)
{
	int getlen=3*1024;
	ifstream in(afile, ios::binary);
	ofstream ou(tfile, ios::trunc);

	while(1)
	{
		memset(szStr,0,MAX_EDIT);
		szResult[0]=0;
		in.read(szStr,getlen);
		encode(szStr,szResult,FALSE);
		ou<<szResult<<endl;
		if(in.eof()) break;
	}
}

*/